clear all
close all
clc
%%%%%%%%%%%%%%%%%%%    Parameter
PRF=1000;       % Pulse repetition frequency
Beam_width=3;   % Beam width
w_scan=60;      % Scanning speed
FOV=18;         % Scanning scope
%%%%%%%%%%%%%%%%%%%    Construct scenario
N=FOV/w_scan*PRF;
scenario=zeros(1,N);
scenario(150)=1;
scenario(100)=0.5;
scenario(200)=1;
aa=linspace(-FOV/2,FOV/2,N);
figure
plot(aa,scenario)
title('Truth')
xlabel('Angle (Degree)')
ylabel('Normalized Amplitude')
%%%%%%%%%%%%%%%%%%    Construct antenna pattern
nMain=PRF*Beam_width/w_scan;
nMain=ceil(nMain/0.443);
t=linspace(-1,1,nMain);
anten=sinc(t).^2;
figure
plot(anten)
title('Antenna pattern')
%%%%%%%%%%%%%%%%%%%   Real beam echo
y=conv(scenario,anten,'same');
yn=awgn(y,20,'measured');
figure
plot(aa,yn)
title('Real beam echo')
xlabel('Angle (Degree)')
ylabel('Normalized Amplitude')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  Online SPICE with regularization
RSPICE=deconvSPICE_OL(abs(yn),anten,10,0.1);
RSPICE=RSPICE/max(max(RSPICE));
RSPICE=RSPICE/max(max(RSPICE));
figure
plot(aa,abs(RSPICE))
title('Online SPICE with regularization')
xlabel('Angle (Degree)')
ylabel('Normalized Amplitude')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  Online SPICE without regularization
RSPICE=deconvSPICE_OL(abs(yn),anten,10,0.0);
RSPICE=RSPICE/max(max(RSPICE));
RSPICE=RSPICE/max(max(RSPICE));
figure
plot(aa,abs(RSPICE))
title('Online SPICE without regularization')
xlabel('Angle (Degree)')
ylabel('Normalized Amplitude')